diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 80b48f760..18a77b08b 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -350,7 +350,7 @@ public class Minecraft
 		resolution.getSetGuiScale();
 		resolution.update();
 		
-		Display.setVSyncEnabled(gameSettings.limitFramerate.value == 3);
+		Display.setVSyncEnabled(gameSettings.enableVsync.value);
 		if (!gameSettings.disableResize.value) {
 			gameWindow.setResizable(true);
 		}
@@ -1420,7 +1420,7 @@ public class Minecraft
                         else if (Keyboard.getEventKey() == Keyboard.KEY_F7) {
                             render.reload();
                         }
-                        else if ((isMultiplayerWorld() || theWorld.getLevelData().getCheatsEnabled()) && gameSettings.keyCommand.isPressed())
+                        else if (gameSettings.keyCommand.isPressed())
                         {
                             displayGuiScreen(new GuiChat("/"));
                         }
@@ -1588,7 +1588,7 @@ public class Minecraft
         }
 
         // Open chat
-        if ((isMultiplayerWorld() || theWorld.getLevelData().getCheatsEnabled()) && gameSettings.keyChat.isPressEvent(currentInputDevice)) {
+        if (gameSettings.keyChat.isPressEvent(currentInputDevice)) {
             displayGuiScreen(new GuiChat());
             return true;
         }
@@ -2208,7 +2208,7 @@ public class Minecraft
         thePlayer = (EntityPlayerSP)playerController.createPlayer(theWorld);
         thePlayer.dimension = i;
         thePlayer.setGamemode(playerGamemode);
-        thePlayer.messages = previousPlayer.messages;
+        thePlayer.messageHistory = previousPlayer.messageHistory;
         activeCamera = new EntityCameraFirstPerson(this, thePlayer);
         thePlayer.resetPos();
         
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 0c15d5cb5..7eaa8b089 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -56,6 +56,7 @@ public class RichPresenceHandlerThread extends Thread
         biomeNamesMap.put(Biomes.OVERWORLD_HELL, "a ruined world");
         biomeNamesMap.put(Biomes.OVERWORLD_SWAMPLAND_MUDDY, "the swamplands");
         biomeNamesMap.put(Biomes.OVERWORLD_OUTBACK_GRASSY, "the outback");
+        biomeNamesMap.put(Biomes.OVERWORLD_CAATINGA, "the caatinga");
     }
     private static Map<Weather, String> weatherNamesMap = new HashMap<>();
     static
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java b/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
index 2928640f2..4a7ef626d 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityClientPlayerMP.java
@@ -172,7 +172,7 @@ public class EntityClientPlayerMP extends EntityPlayerSP
 	public void sendChatMessage(String s)
     {
         sendQueue.addToSendQueue(new Packet3Chat(s, AES.clientKeyChain));
-        mc.thePlayer.messages.add(s);
+    	addToSendHistory(s);
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
index 0f18bce45..0fc8b0427 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
@@ -341,7 +341,7 @@ public class EntityPlayerSP extends EntityPlayer
     }
 
     public void sendChatMessage(String s) {
-        mc.thePlayer.messages.add(s);
+    	addToSendHistory(s);
         if (s.startsWith("/")) {
             try{
                 String[] args = s.substring(1).split(" ");
@@ -376,6 +376,21 @@ public class EntityPlayerSP extends EntityPlayer
         }
     }
     
+    public void addToSendHistory(String msg) {
+    	if(msg == null || msg.isEmpty()) {
+    		return;
+    	}
+    	for(int i=0; i < messageHistory.size(); i++) {
+    		if(messageHistory.get(i).equals(msg)) {
+    			messageHistory.remove(i--);
+    		}
+    	}
+        messageHistory.add(msg);
+        if(messageHistory.size() > 100) {
+        	messageHistory.remove(0);
+        }
+    }
+    
     @Override
     public boolean isSneaking()
     {
diff --git a/src/main/java/net/minecraft/client/gui/GuiChat.java b/src/main/java/net/minecraft/client/gui/GuiChat.java
index 218e3e4e8..7961affb1 100644
--- a/src/main/java/net/minecraft/client/gui/GuiChat.java
+++ b/src/main/java/net/minecraft/client/gui/GuiChat.java
@@ -60,12 +60,12 @@ public class GuiChat extends GuiScreen implements ITextField {
 
 	@Override
 	public void keyTyped(char c, int key, int mouseX, int mouseY) {
-		if (key == Keyboard.KEY_UP && mc.thePlayer.messages.size() > 0) {
+		if (key == Keyboard.KEY_UP && mc.thePlayer.messageHistory.size() > 0) {
 			if (currentIndex == 0)
 			{
 				originalMessage = getText();
 			}
-			if (currentIndex < mc.thePlayer.messages.size())
+			if (currentIndex < mc.thePlayer.messageHistory.size())
 			{
 				currentIndex++;
 				setText(getMessage(currentIndex));
@@ -179,6 +179,6 @@ public class GuiChat extends GuiScreen implements ITextField {
 
 	private String getMessage(int currentIndex)
 	{
-		return mc.thePlayer.messages.get(mc.thePlayer.messages.size()-currentIndex);
+		return mc.thePlayer.messageHistory.get(mc.thePlayer.messageHistory.size()-currentIndex);
 	}
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java b/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
index a53a38433..468a8d6f1 100644
--- a/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
+++ b/src/main/java/net/minecraft/client/gui/GuiConnectToIP.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.ServerAddress;
 import org.lwjgl.input.Keyboard;
 
 // Referenced classes of package net.minecraft.src:
@@ -55,48 +56,11 @@ public class GuiConnectToIP extends GuiScreen
         } else
         if(button.id == 0)
         {
-            String s = field_22111_h.getText().trim();
-            mc.gameSettings.lastServer.value = s.replaceAll(":", "_");
+            String serverUrl = field_22111_h.getText().trim();
+            mc.gameSettings.lastServer.value = serverUrl.replaceAll(":", "_");
             mc.gameSettings.saveOptions();
-            String as[] = s.split(":");
-            if(s.startsWith("["))
-            {
-                int i = s.indexOf("]");
-                if(i > 0)
-                {
-                    String s1 = s.substring(1, i);
-                    String s2 = s.substring(i + 1).trim();
-                    if(s2.startsWith(":") && s2.length() > 0)
-                    {
-                        s2 = s2.substring(1);
-                        as = new String[2];
-                        as[0] = s1;
-                        as[1] = s2;
-                    } else
-                    {
-                        as = new String[1];
-                        as[0] = s1;
-                    }
-                }
-            }
-            if(as.length > 2)
-            {
-                as = new String[1];
-                as[0] = s;
-            }
-            mc.displayGuiScreen(new GuiConnecting(mc, as[0], as.length <= 1 ? 25565 : parseIntWithDefault(as[1], 25565)));
-        }
-    }
-
-    private int parseIntWithDefault(String s, int i)
-    {
-        try
-        {
-            return Integer.parseInt(s.trim());
-        }
-        catch(Exception exception)
-        {
-            return i;
+            ServerAddress address = ServerAddress.resolveServerIP(serverUrl);
+            mc.displayGuiScreen(new GuiConnecting(mc, address.getIP(), address.getPort()));
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/GuiIngame.java
index 989fbdf29..ea0dc51f9 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngame.java
@@ -20,6 +20,7 @@ import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.ChatLine;
diff --git a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
index 12335d781..cbb72b334 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
+++ b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
@@ -180,9 +180,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
         clearSearchButton.yPosition = k + 6;
         searchField.xPosition = j + 173;
         searchField.yPosition = k + 7;
-        drawTexturedModalRect(j, k, 0, 0, 169, ySize);
-        drawTexturedModalRect(j + 169, k, 0, 166, 119, 90);
-        drawTexturedModalRect(j + 169, k + 90, 119, 166, 119, 76);
+        drawTexturedModalRect((double)j, (double)k, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
         GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
         GL11.glEnable(2903 /*GL_COLOR_MATERIAL*/);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
diff --git a/src/main/java/net/minecraft/client/gui/GuiSelectServer.java b/src/main/java/net/minecraft/client/gui/GuiSelectServer.java
index 2fdbb1da4..753d91a59 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSelectServer.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSelectServer.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.core.Global;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.SavedServerList;
+import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -194,7 +195,8 @@ public class GuiSelectServer extends GuiScreen {
 		}
 		selected = true;
 		ServerData server = savedServerList.servers.get(selectedServer);
-		mc.displayGuiScreen(new GuiConnecting(mc, server.getHostName(), server.getPort()));
+		ServerAddress address = server.getServerAddress();
+		mc.displayGuiScreen(new GuiConnecting(mc, address.getIP(), address.getPort()));
 	}
 
 	public void deleteWorld(boolean flag, int i) {
diff --git a/src/main/java/net/minecraft/client/gui/GuiTooltip.java b/src/main/java/net/minecraft/client/gui/GuiTooltip.java
index 204842989..6a93bb25e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTooltip.java
+++ b/src/main/java/net/minecraft/client/gui/GuiTooltip.java
@@ -274,7 +274,7 @@ public class GuiTooltip extends Gui
 				}
 			}
 		} else {
-			String translatedName = trans.translateKey(itemStack.getItemName());
+			String translatedName = trans.translateNameKey(itemStack.getItemName());
 			for(char c : translatedName.toCharArray()) {
 				if(Character.isLetterOrDigit(c))
 					text.append("?");
diff --git a/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
new file mode 100644
index 000000000..407bde2c9
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
@@ -0,0 +1,42 @@
+package net.minecraft.client.gui.options.components;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.RangeOption;
+import net.minecraft.client.render.window.GameWindowLWJGL2;
+
+public class FramerateOptionComponent extends ToggleableOptionComponent<Integer>{
+    public FramerateOptionComponent(RangeOption option) {
+        super(option);
+    }
+    @Override
+    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY)
+    {
+        if (mc.gameSettings.enableVsync.value && mc.gameWindow instanceof GameWindowLWJGL2){
+            slider.sliderValue = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency();
+            slider.displayString = this.option.getDisplayStringValue();
+            slider.enabled = false;
+        }else {
+            slider.sliderValue = option.value;
+            slider.displayString = this.option.getDisplayStringValue();
+            slider.enabled = true;
+        }
+
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.slider.xPosition = x + relativeButtonX;
+        this.slider.yPosition = y + relativeButtonY;
+        this.slider.width = buttonWidth;
+        this.slider.height = buttonHeight;
+
+        this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+    }
+    @Override
+    public void init(Minecraft mc){
+        slider.sliderValue = option.getValueIndex();
+        if (mc.gameSettings.enableVsync.value && mc.gameWindow instanceof GameWindowLWJGL2){
+            slider.sliderValue = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency();
+            slider.enabled = false;
+        }
+        this.slider.displayString = this.option.getDisplayStringValue();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
index 0825c94dc..3e5b789a0 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
@@ -8,7 +8,7 @@ public class ToggleableOptionComponent<E>
         extends ButtonComponent
 {
     protected final ToggleableOption<E> option;
-    private final GuiSliderInteger slider;
+    protected final GuiSliderInteger slider;
 
     public ToggleableOptionComponent(ToggleableOption<E> option)
     {
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 31ad8a28b..1b75daccd 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -72,8 +72,8 @@ public abstract class OptionsPages
             .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.colorblindnessFix))
         )
         .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
-            .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.limitFramerate))
-            .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.customFpsLimit))
+            .withComponent(new BooleanOptionComponent(mc.gameSettings.enableVsync))
+            .withComponent(new FramerateOptionComponent(mc.gameSettings.customFpsLimit))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.advancedOpenGL))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.enableVbos))
         )
